const EventEmitter = require('events')

class NoWorkerErrorFor extends EventEmitter {
  command (version, content) {
    this.api.perform((done) => {
      noWorkerErrorFor(this.api, version, content, () => {
        done()
        this.emit('complete')
      })
    })
    return this
  }
}

function noWorkerErrorFor (browser, version, done) {
  browser
    .clickLaunchIcon('solidity')
    .setSolidityCompilerVersion(version)
    .pause(5000)
    .getAttribute('*[data-id="compilerContainerCompileBtn]"', 'disabled', function(result){ this.assert.equal(result.value, null) // element not disabled
    .waitForElementPresent('*[data-id="compiledErrors"]')
    .notContainsText('*[data-id="compiledErrors"]', 'worker error:undefined')
    .notContainsText('*[data-id="compiledErrors"]', 'Uncaught RangeError: Maximum call stack size exceeded')
    .notContainsText('*[data-id="compiledErrors"]', 'RangeError: Maximum call stack size exceeded')
    .perform(function (done) {
      done()
    })
}

module.exports = NoWorkerErrorFor
